## proxy_gol.php?url=https%3A%2F%2Fgithub.com%2Fbmdcpp%2Fbmdc%2Fzipball%2Fmaster

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.0)
cmake_policy(VERSION 3.0)

project(bmdc
	VERSION 0.1.16
	LANGUAGES C CXX)
set(PROJECT_BUGREPORT "https://bugs.launchpad.net/bmdc++")
set(PROJECT_URL "http://freedcppmv.sourceforge.net/doku.php/mainpage")
#for now always use stacktrace
#-Wall 
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -D_LARGEFILE_SOURCE -DUSE_STACKTRACE -D_FILE_OFFSET_BITS=64 -D_REENTRANT")
# Required for FindIntltool module
set(GETTEXT_PACKAGE ${PROJECT_NAME})
set(GETTEXT_PO_DIR ${CMAKE_SOURCE_DIR}/po)

# Keep these two definitions in agreement.
set(glib_minimum_version 2.46)
set(glib_encoded_version GLIB_VERSION_2_46)

# Keep these two definitions in agreement.
set(gdk_minimum_version 3.10)
set(gdk_encoded_version GDK_VERSION_3_10)

# Warn about API usage that violates our minimum requirements.
#add_definitions(-DGLIB_VERSION_MAX_ALLOWED=${glib_encoded_version})
#add_definitions(-DGDK_VERSION_MAX_ALLOWED=${gdk_encoded_version})
set(gdk_pixbuf_minimum_version 2.24.0)
set(gladeui_minimum_version 3.10.0)

# Load modules from the source tree
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_SKIP_BUILD_RPATH OFF)
set(CMAKE_BUILD_WITH_INSTALL_RPATH OFF)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH ON)
# CMAKE_INSTALL_RPATH is set below

# CMake modules
include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckLibraryExists)
include(FindMiniupnpc)

# Project custom modules
include(PrintableOptions)


add_printable_variable(LIB_SUFFIX "Library directory suffix, usually defined to '64' for x86_64 systems" "")
add_printable_variable_bare(CMAKE_INSTALL_PREFIX)
add_printable_variable_path(BIN_INSTALL_DIR "Install directory for binary files, defaults to CMAKE_INSTALL_PREFIX/bin" "")
add_printable_variable_path(INCLUDE_INSTALL_DIR "Install directory for header files, defaults to CMAKE_INSTALL_PREFIX/include" "")
add_printable_variable_path(LIB_INSTALL_DIR "Install directory for library files, defaults to CMAKE_INSTALL_PREFIX/lib{LIB_SUFFIX}" "")
add_printable_variable_path(LIBEXEC_INSTALL_DIR "Install directory for library executable files, defaults to CMAKE_INSTALL_PREFIX/libexec" "")
add_printable_variable_path(SHARE_INSTALL_PREFIX "Install directory for shared files, defaults to CMAKE_INSTALL_PREFIX/share" "")
add_printable_variable_path(LOCALE_INSTALL_DIR "Install directory for locale files, defaults to SHARE_INSTALL_PREFIX/locale" "")
add_printable_variable_path(SYSCONF_INSTALL_DIR "Install directory for system configuration files, defaults to CMAKE_INSTALL_PREFIX/etc" "")

macro(ensure_default_value _var _defvalue)
	if(${_var} STREQUAL "")
		set(${_var} ${_defvalue})
	endif(${_var} STREQUAL "")
endmacro(ensure_default_value)

ensure_default_value(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
ensure_default_value(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include")
ensure_default_value(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
ensure_default_value(LIBEXEC_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/libexec")
ensure_default_value(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share")
ensure_default_value(LOCALE_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/locale")
ensure_default_value(SYSCONF_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/etc")


include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckFunctionExists)
include (FindPkgConfig)
include (CheckCXXSourceCompiles)


include(CodeCoverageGCOV)
include(CheckTarget)

include(GLibTools)
include(GtkDoc)
include(IconCache)

include(PkgConfigEx)
include(SetupBuildFlags)

include(FindIntltool)


add_printable_option(ENABLE_MAINTAINER_MODE "Enable maintainer mode" OFF)
add_printable_variable(VERSION_SUBSTRING "Version substring, for packagers" "")
add_printable_variable(VERSION_COMMENT "Define if you want a comment appended to the version number" "")


if(ENABLE_MAINTAINER_MODE)
	set(BUILD_TESTING ON)
endif(ENABLE_MAINTAINER_MODE)

# Setup compiler/linker flags
setup_build_flags(${ENABLE_MAINTAINER_MODE})

set(MATH_LDFLAGS -lm)

CHECK_INCLUDE_FILE(sys/wait.h HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILE(X11/XF86keysym.h HAVE_XFREE)
CHECK_FUNCTION_EXISTS(mkdtemp HAVE_MKDTEMP)
CHECK_FUNCTION_EXISTS(nl_langinfo HAVE_NL_LANGINFO)

 #******************************
# Check for nl_langinfo features
# ******************************

CHECK_C_SOURCE_COMPILES("#include <langinfo.h>
			int main(void) { char *detail = nl_langinfo (_NL_MEASUREMENT_MEASUREMENT); return 0; }" HAVE__NL_MEASUREMENT_MEASUREMENT)

# ******************************
# Dependencies
# ******************************

if(WIN32)
	set(GIO_UNIX_REQUIREMENT "gio-windows-2.0")
else(WIN32)
	set(GIO_UNIX_REQUIREMENT "gio-unix-2.0")
endif(WIN32)


pkg_check_modules(GTK_PLATFORM REQUIRED cairo-gobject
	gdk-pixbuf-2.0>=${gdk_pixbuf_minimum_version}
	gio-2.0>=${glib_minimum_version}
	${GIO_UNIX_REQUIREMENT}
	gmodule-2.0>=${glib_minimum_version}
	gtk+-3.0>=${gdk_minimum_version}
	glib-2.0
	
)
#INCLUDE(FindPackageHandleStandardArgs)

find_package (PkgConfig)
find_package (BZip2 REQUIRED)
find_package (ZLIB REQUIRED)
find_package (OpenSSL REQUIRED)
find_package (GeoIP REQUIRED)
find_package (Xattr)
find_package(Pcre)

if (USE_MINIUPNP)
    message (STATUS "Building with UPNP support (miniupnpc)")
    set (MINIUPNP_INCLUDE_DIR)
    set (MINIUPNP_LIBRARY)
  if (LOCAL_MINIUPNP)
    add_subdirectory(miniupnpc)
    set (MINIUPNP_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/miniupnpc")
    set (MINIUPNP_LIBRARY "miniupnpc")
    set(HAVE_LOCAL_MINIUPNPC ON)
  else (LOCAL_MINIUPNP)
    find_package (Miniupnpc REQUIRED)
  endif (LOCAL_MINIUPNP)

elseif (NOT USE_MINIUPNP)
    unset (MINIUPNP_INCLUDE_DIR CACHE)
    unset (MINIUPNP_LIBRARY CACHE)
    message (STATUS "Building without UPNP support (miniupnpc)")
endif(USE_MINIUPNP)

# ******************************
# Canberra / Canberra-GTK Sound
# ******************************

add_printable_option(ENABLE_CANBERRA "Enable Canberra and Canberra-GTK sound" ON)

if(ENABLE_CANBERRA)
	pkg_check_modules_for_option(ENABLE_CANBERRA "Canberra and Canberra-GTK sound" CANBERRA libcanberra-gtk3>=${libcanberra_gtk_minimum_version})
	set(HAVE_CANBERRA ON)
endif(ENABLE_CANBERRA)

# ******************************
# iconv checking
# ******************************

#set(CMAKE_REQUIRED_LIBRARIES "-liconv")
#CHECK_C_SOURCE_COMPILES("#include <iconv.h>
#			#include <stdlib.h>
#			int main(void) { iconv_t cd; cd = iconv_open (\"UTF-8\", \"ISO-8859-1\"); return 0; }" HAVE_LIBICONV)
#unset(CMAKE_REQUIRED_LIBRARIES)

#if(HAVE_LIBICONV)
#	set(ICONV_LIBS "-liconv")
#	set(HAVE_ICONV ON)
#else(HAVE_LIBICONV)
#	set(ICONV_LIBS "")
#	CHECK_FUNCTION_EXISTS(iconv HAVE_ICONV)
#endif(HAVE_LIBICONV)

#if(NOT HAVE_ICONV)
#	message(FATAL_ERROR "You need to install a working iconv implementation, such as ftp://ftp.gnu.org/pub/gnu/libiconv")
#endif(NOT HAVE_ICONV)

#set(CMAKE_REQUIRED_LIBRARIES ${ICONV_LIBS})
#CHECK_C_SOURCE_RUNS("#include \"${CMAKE_SOURCE_DIR}/iconv-detect.c\"" _correct_iconv)
#unset(CMAKE_REQUIRED_LIBRARIES)

#if(NOT _correct_iconv)
#	message(FATAL_ERROR "You need to install a working iconv implementation, such as ftp://ftp.gnu.org/pub/gnu/libiconv")
#endif(NOT _correct_iconv)

# ******************************
# Libnotify
# ******************************

#pkg_check_modules(LIBNOTIFY libnotify>=${libnotify_minimum_version})
#set(HAVE_LIBNOTIFY ${LIBNOTIFY_FOUND})

# Generate the ${PROJECT_NAME}-config.h file
#CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/config.h.in ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.h)
#IF (WIN32)
#empty
#else(WIN32)
	message(STATUS "Building needed files...")
	execute_process(COMMAND "${CMAKE_SOURCE_DIR}/linux/gen-cmake.sh" "${CMAKE_SOURCE_DIR}")
#ENDIF(WIN32)
print_build_options()

add_subdirectory(natpmp)

add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(dcpp)
add_subdirectory(linux)
install(DIRECTORY icons country emoticons  DESTINATION share/bmdc)
install(DIRECTORY extensions/Scripts/ DESTINATION share/bmdc/extensions/Scripts)
#add_subdirectory(tests)

#if(ENABLE_GTK_DOC)
#	add_subdirectory(docs)
#endif(ENABLE_GTK_DOC)

=== Makefile ===
all:
	mkdir -p ${HOME}/BMDC/
	scons PREFIX=${HOME}/BMDC/ release=1
	scons install
Release:
	mkdir -p ${HOME}/BMDC-release/
	scons PREFIX=${HOME}/BMDC-release/ release=1 libxattr=0 newSettings=1 -j3
	scons install
	chmod +x ${HOME}/BMDC-release/bin/bmdc
Debug:
	mkdir -p ${HOME}/debug
	scons PREFIX=${HOME}/debug/ debug=1 profile=0 useStatusIcon=1 libxattr=1 newSettings=1 -j4
cleanrelease:
	scons -c
cleandebug:
	scons debug=1 -c

=== SConstruct ===
#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import subprocess
import string
import re
import fileinput
import sys
from sys import platform as _platform

EnsureSConsVersion(0, 98, 1)

PACKAGE = 'bmdc'
CORE_PACKAGE = 'libdcpp'
LIB_UPNP = 'libminiupnpc'
LIB_NATPMP = 'libnatpmp'
BUILD_PATH = '#/build/'
BUILD_LOCALE_PATH = BUILD_PATH + 'locale/'
LIB_IS_UPNP = True
LIB_IS_NATPMP = True
LIB_IS_GEO = False
LIB_IS_TAR = False
LIB_HAVE_XATTR = False
NEW_SETTING = True

BUILD_FLAGS = {#'-Wno-unused-parameter','-Wno-unused-value',
	'common'  : ['-I#','-D_GNU_SOURCE', '-D_LARGEFILE_SOURCE', '-D_FILE_OFFSET_BITS=64', '-D_REENTRANT','-pipe','-DUSE_STACKTRACE=1','-DUSE_NEW_SETTINGS=1' ,'-fpermissive'],
	'debug'   : ['-O1','-g', '-ggdb','-W', '-Wall','-Wextra','-D_DEBUG' ,'-DUSE_ADDR2LINE','-Wno-reorder','-DGDK_DISABLE_DEPRECATED','-DGTK_DISABLE_DEPRECATED','-Wno-unused-parameter','-Wno-unused-value','-Wno-format','-Wfatal-errors'],
	'release' : ['-O3', '-fomit-frame-pointer', '-DNDEBUG']
}

# ----------------------------------------------------------------------
# Function definitions
# ----------------------------------------------------------------------

def check_pkg_config(context,name):
	context.Message('Checking for %s... ' % name)
	ret = subprocess.run([name, '-dumpversion'],capture_output=True)

	retval = 0
	try:
		retval = 1
	except ValueError:
		print ("No pkg-config found!")

	context.Result(retval)
	return retval

def check_pkg(context, name):
	context.Message('Checking for %s... ' % name)
	ret = context.TryAction('pkg-config --exists \'%s\'' % name)[0]
	context.Result(ret)
	return ret

def check_cxx_version(context, name, major, minor):
	context.Message('Checking for %s >= %d.%d...' % (name, major, minor))
	ret = subprocess.run([name, '-dumpversion'],capture_output=True)

	retval = 0
	try:
		if ret.stdout[0] > major:
			retval = 1

	except ValueError:
		print ("No C++ compiler found!")

	context.Result(retval)
	return retval
#
# Recursively installs all files within the source folder to target. Optionally,
# a filter function can be provided to prevent installation of certain files.
def recursive_install(env, source, target, filter = None):
	nodes = env.Glob(os.path.join(source, '*'))
	target = os.path.join(target, os.path.basename(source))

	for node in nodes:
		if node.isdir():
			env.RecursiveInstall(str(node), target, filter)
		elif filter == None or filter(node.name):
			env.Alias('install', env.Install(target, node))

def generate_message_catalogs(env):
	mo_path = os.path.join(BUILD_LOCALE_PATH, '%s', 'LC_MESSAGES', env['package'] + '.mo')
	po_files = env.Glob('po/*.po', strings = True)

	for po_file in po_files:
		basename = os.path.basename(po_file)
		lang = os.path.splitext(basename)[0]
		mo_file = mo_path % lang
		env.MoBuild(source = po_file, target = mo_file)

	return None

def replaceAll(env,file,searchExp,replaceExp):
	for line in fileinput.input(file, inplace=1):
		if searchExp in line:
			line = line.replace(searchExp,replaceExp)
	sys.stdout.write(line)

# ----------------------------------------------------------------------
# Command-line options
# ----------------------------------------------------------------------

# Parameters are only sticky from scons -> scons install, otherwise they're cleared.
if 'install' in COMMAND_LINE_TARGETS:
	vars = Variables('build/sconf/scache.conf')
else:
	vars = Variables()

vars.AddVariables(
	BoolVariable('debug', 'Compile the program with debug information', 0),
	BoolVariable('release', 'Compile the program with optimizations', 0),
	BoolVariable('profile', 'Compile the program with profiling information', 0),
	BoolVariable('libnotify', 'Enable notifications through libnotify', 0),
	BoolVariable('libtar', 'Enable Backup&Export with libtar', 1),
	BoolVariable('libxattr', 'Enable xattr support for storing calculated Hash in extended attributes of file', 0),
	BoolVariable('newSettings', 'Use new Settings dialog UI', 0),
	PathVariable('PREFIX', 'Compile the program with PREFIX as the root for installation', '/usr/local/', PathVariable.PathIsDir),
	('FAKE_ROOT', 'Make scons install the program under a fake root', '')
)

# ----------------------------------------------------------------------
# Initialization
# ----------------------------------------------------------------------

env = Environment(ENV = os.environ, variables = vars, package = PACKAGE)

env['mode'] = 'debug' if env.get('debug') else 'release'
env['build_path'] = BUILD_PATH + env['mode'] + '/'

if 'CXX' in os.environ:
	env['CXX'] = os.environ['CXX']
	if(os.environ['CXX'] == 'clang++'):
		env.Append( CPPPATH ='/usr/include/')
		env.Append( CXXFLAGS ='-Wno-overloaded-virtual')
else:
	print ('CXX env variable is not set, attempting to use g++')
	env['CXX'] = 'g++'

if 'CC' in os.environ:
	env['CC'] = os.environ['CC']

if 'CXXFLAGS' in os.environ:
	env['CPPFLAGS'] = env['CXXFLAGS'] = os.environ['CXXFLAGS'].split()

if 'LDFLAGS' in os.environ:
	env['LINKFLAGS'] = os.environ['LDFLAGS'].split()

if 'CFLAGS' in os.environ:
	env['CFLAGS'] = os.environ['CFLAGS'].split()

if 'CPPPATH' in os.environ:
	env['CPPPATH'] = os.environ['CPPPATH'].split()

env['PKG_CONFIG'] = 'pkg-config'
if 'PKG_CONFIG' in os.environ:
	env['PKG_CONFIG'] = os.environ['PKG_CONFIG']

env['CPPDEFINES'] = [] # Initialize as a list so Append doesn't concat strings

env.SConsignFile('build/sconf/.sconsign')
vars.Save('build/sconf/scache.conf', env)
Help(vars.GenerateHelpText(env))

pot_args = ['xgettext', '--default-domain=$PACKAGE', '--package-name=$PACKAGE',
		'--msgid-bugs-address=https://github.com/bmdcpp/bmdc',
		'--copyright-holder=BMDC++ Team', '--add-comments=TRANSLATORS',
		'--keyword=_', '--keyword=N_', '--keyword=C_:1c,2', '--keyword=F_',
		'--keyword=P_:1,2', '--from-code=UTF-8', '--foreign-user',
		'--no-wrap', '--boost', '--sort-output', '--language=$LANGUAGE',
		'--output=$TARGET', '$SOURCES']
pot_build = Builder(action = Action([pot_args], 'Extracting messages to $TARGET from $SOURCES'))
env.Append(BUILDERS = {'PotBuild' : pot_build})

merge_pot_args = ['msgcat', '$SOURCES', '--output-file=$TARGET']
merge_pot_builder = Builder(action = Action([merge_pot_args], 'Merging pot files $SOURCES to $TARGET'))
env.Append(BUILDERS = {'MergePotFiles' : merge_pot_builder})

mo_args = ['msgfmt', '-c', '-o', '$TARGET', '$SOURCE']
mo_build = Builder(action = Action([mo_args], 'Compiling message catalog $TARGET from $SOURCES'))
env.Append(BUILDERS = {'MoBuild' : mo_build})

env.AddMethod(generate_message_catalogs, 'GenerateMessageCatalogs')
env.AddMethod(recursive_install, 'RecursiveInstall')

env.AddMethod(replaceAll,'ReplaceAll')

conf = env.Configure(
	custom_tests =
	{
		'CheckPKGConfig' : check_pkg_config,
		'CheckPKG' : check_pkg,
		'CheckCXXVersion' : check_cxx_version,
	},
	conf_dir = 'build/sconf',
	log_file = 'build/sconf/config.log')

# ----------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------

if not 'install' in COMMAND_LINE_TARGETS:
	if not conf.CheckCXXVersion(env['CXX'], 5, 0):
		print ('Compiler version check failed. g++ 5 or later is needed')
		Exit(1)
	elif env['CXX'] == 'clang++':
		print ('Use clang compiler')
		env.Append(CXXFLAGS = ['-I/usr/include/','-Wno-overloaded-virtual','-pthread'])
		env.Append(CFLAGS = '-I/usr/include/')
		env.Append( CPPPATH ='/usr/include/')
		env.Append( LIBS = 'pthread')
		env.Append( LINKFLAGS = '-lpthread')

	if not conf.CheckPKGConfig(env['PKG_CONFIG']):
		print ('\tpkg-config not found.')
		Exit(1)

	if not conf.CheckPKG('gtk4 > 4.00'):
		print ('\tgtk+ >= 4.00 not found.')
		print ('\tNote: You might have the lib but not the headers')
		Exit(1)

	if not conf.CheckHeader('time.h'):
		 Exit(1)

	if not conf.CheckHeader('signal.h'):
		Exit(1)

	if not conf.CheckHeader('unistd.h'):
		Exit(1)

	if not conf.CheckLibWithHeader('pthread', 'pthread.h', 'c'):
		print ('\tpthread library not found')
		print ('\tNote: You might have the lib but not the headers')
		Exit(1)

	if not conf.CheckLibWithHeader('z', 'zlib.h', 'c'):
		print ('\tz library (gzip/z compression) not found')
		print ('\tNote: You might have the lib but not the headers')
		Exit(1)

	if not conf.CheckLibWithHeader('bz2', 'bzlib.h', 'c'):
		print ('\tbz2 library (bz2 compression) not found')
		print ('\tNote: You might have the lib but not the headers')
		Exit(1)

	# This needs to be before ssl check on *BSD systems
	if not conf.CheckLib('crypto'):
		print ('\tcrypto library not found')
		print ('\tNote: This library may be a part of libssl on your system')
		Exit(1)

	if not conf.CheckLibWithHeader('ssl', 'openssl/ssl.h', 'c'):
		print ('\tOpenSSL library (libssl) not found')
		print ('\tNote: You might have the lib but not the headers')
		Exit(1)
	#Fedora dont have EC
	if not conf.CheckHeader('openssl/ec.h'):
		print ('\tOpenSSL Don`t have an EC Extesions')
		conf.env.Append(CPPDEFINES = ('DHAVE_EC_CRYPTO'))

	if not conf.CheckHeader('iconv.h'):
		print ('\t No Iconv found you may have lib but not headers')
		Exit(1)
	elif conf.CheckLibWithHeader('iconv', 'iconv.h', 'c', 'iconv(0, (const char **)0, 0, (char**)0, 0);'):
		conf.env.Append(CPPDEFINES = ('ICONV_CONST', 'const'))

	if conf.CheckHeader(['sys/types.h', 'sys/socket.h', 'ifaddrs.h', 'net/if.h']):
		conf.env.Append(CPPDEFINES = 'HAVE_IFADDRS_H')

	#assumes we had also headers..
	if conf.env.get('libxattr'):
		if conf.CheckLib('attr'):
			conf.env.Append(CPPDEFINES = 'USE_XATTR')
			LIB_HAVE_XATTR = True

	if conf.env.get('libnotify'):
			if not conf.CheckPKG('libnotify >= 0.4.1'):
				print ('\tlibnotify >= 0.4.1 not found, disabling notifications.')
				print ('\tNote: You might have the lib but not the headers')
			else:
				conf.env.Append(CPPDEFINES = 'HAVE_NOTIFY')
				conf.env.ParseConfig('pkg-config --libs --cflags libnotify')
				if conf.CheckPKG('libnotify >= 0.7'):
					conf.env.Append(CPPDEFINES = 'HAVE_LIBNOTIFY_0_7')

	# Check for MiniUPnPc
	if not conf.CheckLib('libminiupnpc'):
		LIB_IS_UPNP = False
	if not conf.CheckLib('miniupnpc'):
		LIB_IS_UPNP = False	
	# Check for natpmp
	if not conf.CheckLib('libnatpmp'):
		LIB_IS_NATPMP = False
	# Check for natpmp
	if not conf.CheckLib('natpmp'):
		LIB_IS_NATPMP = False	

	# GeoIp
	if conf.CheckHeader('maxminddb.h'):
		print ('\tFound maxminddb headers.')
		conf.env.Append(CPPDEFINES = 'HAVE_GEOIPLIB')
		LIB_IS_GEO = True
	else:
		print ('\tDont Found maxminddb headers.')

	# libtar for Backup/Restore man...
	if conf.env.get('libtar'):
		if conf.CheckHeader('libtar.h'):
			print ('\tFound Libtar headers.')
			conf.env.Append(CPPDEFINES = 'HAVE_LIBTAR')
			LIB_IS_TAR = True
		else:
			print ('\tDont Found libtar headers.')
			LIB_IS_TAR = False

	if conf.env.get('newSettings'):
		conf.env.Append(CPPDEFINES = 'USE_NEW_SETTINGS')
		NEW_SETTING = True

	env = conf.Finish()

# ----------------------------------------------------------------------
# Compile and link flags
# ----------------------------------------------------------------------
	#_platform = 'win32'#flag for cross enable compile
	env.MergeFlags(BUILD_FLAGS['common'])
	env.MergeFlags(BUILD_FLAGS[env['mode']])

	env.Append(CXXFLAGS = '-std=c++17')
	env.Append(LIBS = ['pcre2'])
	env.Append(LINKFLAGS = ['-lpcre2-8'])
	#temp
	env.Append(LIBS = ['maxminddb'])
	env.Append(LINKFLAGS = ['-lmaxminddb'])

	env.Append(CPPDEFINES = ['STATICLIB'])
	env.Append(CPPPATH = '#/natpmp')
	env.Append(LIBS = 'natpmp')
	env.Append(CPPPATH = '#/miniupnp')
	env.Append(LIBS = 'miniupnpc')

	if LIB_HAVE_XATTR:
		env.Append(LIBS='attr')
		env.Append(LINKFLAGS='-lattr')

	env.ParseConfig('pkg-config --libs gtk4')
	#env.ParseConfig('pkg-config --libs bz2')
	
	env.ParseConfig('pkg-config --cflags glib-2.0')
	env.ParseConfig('pkg-config --libs glib-2.0')

	env.Append(LIBPATH = env['build_path'] + CORE_PACKAGE)
	env.Prepend(LIBS = 'dcpp')

	if os.sys.platform == 'linux2':
		env.Append(LINKFLAGS = '-Wl,--as-needed')

=== data/CMakeLists.txt ===
set(filedeps)
set(desktopdir ${SHARE_INSTALL_PREFIX}/applications)

install(FILES ${CMAKE_SOURCE_DIR}/data/bmdc.desktop
	DESTINATION ${desktopdir}
)

=== dcpp/CMakeLists.txt ===
set(SOURCES
format.cpp
AdcCommand.cpp 
AdcHub.cpp 
ADLSearch.cpp 
AVManager.cpp 
BackupManager.cpp 
BMDCUtil.cpp 
BufferedSocket.cpp 
BZUtils.cpp 
CID.cpp 
Client.cpp 
ClientManager.cpp 
CommandQueue.cpp 
ConnectionManager.cpp 
ConnectivityManager.cpp 
CryptoManager.cpp 
DCPlusPlus.cpp 
DebugManager.cpp 
DetectionManager.cpp 
DirectoryListing.cpp 
Download.cpp 
DownloadManager.cpp 
Encoder.cpp 
Exception.cpp 
ExportManager.cpp 
FakeChecker.cpp 
FavoriteManager.cpp 
File.cpp 
FileReader.cpp 
FinishedItem.cpp 
FinishedManager.cpp 
GeoIP.cpp 
GeoManager.cpp 
HashBloom.cpp 
HashManager.cpp 
HighlightManager.cpp 
HttpConnection.cpp 
HttpDownload.cpp 
HubSettings.cpp 
ChatMessage.cpp 
LogManager.cpp 
Mapper.cpp 
Mapper_MiniUPnPc.cpp 
Mapper_NATPMP.cpp 
MappingManager.cpp 
NmdcHub.cpp 
PluginApiImpl.cpp 
PluginManager.cpp 
QueueItem.cpp 
QueueManager.cpp 
RawManager.cpp 
SearchManager.cpp 
SearchResult.cpp 
SettingsManager.cpp 
SFVReader.cpp 
ShareManager.cpp 
SimpleXML.cpp 
SimpleXMLReader.cpp 
Socket.cpp 
SSL.cpp 
SSLSocket.cpp 
stdinc.cpp 
StringMatch.cpp 
StringTokenizer.cpp 
TarFile.cpp 
Text.cpp 
Thread.cpp 
ThrottleManager.cpp 
TigerHash.cpp 
TimerManager.cpp 
Transfer.cpp 
Upload.cpp 
UploadManager.cpp 
UserCommand.cpp 
UserConnection.cpp 
User.cpp 
Util.cpp 
version.cpp 
ZUtils.cpp 

)

set(HEADERS
	ActionRaw.h 
AdcCommand.h 
AdcHub.h 
ADLSearch.cpp 
ADLSearch.h 
AVManager.h 
BackupManager.h 
BloomFilter.h 
BMDCUtil.h 
BufferedSocket.h 
BufferedSocketListener.h 
BZUtils.h 
CalcADLAction.h 
CID.h 
Client.h 
ClientListener.h 
ClientManager.h 
ClientManagerListener.h 
ColorSettings.h 
CommandQueue.h 
compiler.h 
ConnectionManager.h 
ConnectionManagerListener.h 
ConnectivityManager.h 
CriticalSection.h 
CryptoManager.h 
DCPlusPlus.h 
debug.h 
DebugManager.h 
DetectionEntry.h 
DetectionManager.h 
DirectoryListing.h 
Download.h 
DownloadManager.h 
DownloadManagerListener.h 
Encoder.h 
Exception.h 
ExportManager.h 
FakeChecker.cpp 
FakeChecker.h 
FavHubGroup.h 
FavoriteManager.h 
FavoriteManagerListener.h 
FavoriteUser.h 
File.h 
FileReader.h 
FilteredFile.h 
FinishedItem.cpp 
FinishedItem.h 
FinishedManager.cpp 
FinishedManager.h 
FinishedManagerListener.h 
Flags.h 
format.h 
forward.h 
GeoIP.h 
GeoManager.h 
GetSet.h 
HashBloom.cpp 
HashBloom.h 
HashManager.cpp 
HashManager.h 
HashManagerListener.h 
HashValue.h 
HighlightManager.cpp 
HighlightManager.h 
HintedUser.h 
HttpConnection.h 
HttpConnectionListener.h 
HttpDownload.h 
HubEntry.h 
HubSettings.h 
HubUsersMap.h 
ChatMessage.cpp 
ChatMessage.h 
LogManager.h 
LogManagerListener.h 
Mapper.h 
Mapper_MiniUPnPc.h 
Mapper_NATPMP.h 
MappingManager.h 
MD5Hash.h 
MediaInfo.h 
MerkleCheckOutputStream.h 
MerkleTree.h 
NmdcHub.h 
noexcept.h 
nullptr.h 
OnlineUser.h 
PluginApiImpl.h 
PluginDefs.h 
PluginEntity.h 
PluginManager.h 
Pointer.h 
portable_endian.h 
QueueItem.h 
QueueManager.h 
QueueManagerListener.h 
RawManager.h 
RegEx.h 
ScopedFunctor.h 
SearchManager.cpp 
SearchManager.h 
SearchManagerListener.h 
SearchResult.cpp 
SearchResult.h 
Segment.h 
Semaphore.h 
SettingsManager.h 
SFVReader.h 
ShareManager.cpp 
ShareManager.h 
SimpleXML.h 
SimpleXMLReader.h 
Singleton.h 
Socket.h 
Speaker.h 
SSL.h 
SSLSocket.h 
stdinc.h 
Streams.h 
StringMatch.cpp 
StringMatch.h 
StringSearch.h 
StringTokenizer.h 
TarFile.h 
TaskQueue.h 
Text.h 
Thread.cpp 
Thread.h 
ThrottleManager.cpp 
ThrottleManager.h 
TigerHash.cpp 
TigerHash.h 
TimerManager.h 
Transfer.h 
typedefs.h 
Upload.h 
UploadManager.h 
UploadManagerListener.h 
UserCommand.h 
UserConnection.h 
UserConnectionListener.h 
User.h 
UserManager.h 
Util.h 
version.h 
w.h 
ZUtils.h 

)

add_library(dcpp
	${SOURCES}
	${HEADERS}
	${CMAKE_SOURCE_DIR}/natpmp
)

target_compile_options(dcpp PUBLIC
	${CANBERRA_CFLAGS}
	${GTK_PLATFORM_CFLAGS}
	${OPENSSL_CFLAGS}
	${GEOIP_CFLAGS}
)

IF (HAVE_LOCAL_MINIUPNPC)

target_compile_definitions(dcpp PRIVATE
"-DHAVE_LOCAL_MINIUPNPC=1"
)
ENDIF (HAVE_LOCAL_MINIUPNPC)

target_include_directories(dcpp PUBLIC
	${CMAKE_BINARY_DIR}
	${CMAKE_BINARY_DIR}/src
	${CMAKE_SOURCE_DIR}/natpmp
	${CANBERRA_INCLUDE_DIRS}
	${GTK_PLATFORM_INCLUDE_DIRS}
	${MINIUPNP_INCLUDE_DIR}
	${OPENSSL_INCLUDE_DIR}
	${GEOIP_INCLUDE_DIR}
	${PCRE_INCLUDE_DIR}
)

target_link_libraries(dcpp
	${DEPENDENCIES}
	${CANBERRA_LDFLAGS}
	${GTK_PLATFORM_LDFLAGS}
	${MINIUPNP_LIBRARY}
	${OPENSSL_LIBRARIES}
	${GEOIP_LIBRARIES}
	${PCRE_LIBRARY}
	${BZIP2_LIBRARIES}
	${ZLIB_LIBRARIES}
)

=== linux/CMakeLists.txt ===
set(DEPENDENCIES
	natpmp
	dcpp
)

set(SOURCES
	AboutConfig.cc 
AboutConfigFav.cc 
adlsearch.cc 
bacon-message-connection.cc 
bookentry.cc 
cmddebug.cc 
detectiontab.cc 
dialogentry.cc 
diskinfo.cc 
downloadqueue.cc 
emoticons.cc 
emoticonsdialog.cc 
entry.cc 
exportimport.cc 
FavoriteHubDialog.cc 
favoritehubs.cc 
favoriteusers.cc 
finishedtransfers.cc 
freespace.cc 
fsusage.cc 
genres.cc 
hashdialog.cc 
hub.cc 
ignoremenu.cc 
IgnoreTempManager.cc 
mainwindow.cc 
notepad.cc 
notify.cc 
previewmenu.cc 
privatemessage.cc 
publichubs.cc 
recenthub.cc 
search.cc 
SearchEntry.cc 
searchspy.cc 
settingsdialog.cc 
settingsmanager.cc 
sharebrowser.cc 
ShellCommand.cc 
sound.cc 
stacktrace.cc 
System.cc 
transfers.cc 
treeview.cc 
uploadqueue.cc 
UserCommandMenu.cc 
wulfor.cc 
wulformanager.cc 
WulforUtil.cc 

)

set(HEADERS
	AboutConfigFav.hh 
AboutConfig.hh 
adlsearch.hh 
bacon-message-connection.hh 
bookentry.hh 
cmddebug.hh 
detectiontab.hh 
dialogentry.hh 
diskinfo.hh 
downloadqueue.hh 
emoticonsdialog.hh 
emoticons.hh 
entry.hh 
exportimport.hh 
FavoriteHubDialog.hh 
favoritehubs.hh 
favoriteusers.hh 
finishedtransfers.hh 
func.hh 
gtk-fixies.hh 
hashdialog.hh 
hub.hh 
ignoremenu.hh 
IgnoreTempManager.hh 
mainwindow.hh 
message.hh 
notepad.hh 
notify.hh 
previewmenu.hh 
privatemessage.hh 
publichubs.hh 
recenthub.hh 
SearchEntry.hh 
search.hh 
searchspy.hh 
settingsdialog.hh 
settingsmanager.hh 
sharebrowser.hh 
ShellCommand.hh 
sound.hh 
Splash.hh 
stacktrace.hh 
System.hh 
transfers.hh 
treeview.hh 
uploadqueue.hh 
UserCommandMenu.hh 
version.hh 
wulformanager.hh 
WulforUtil.hh 

)

add_executable(bmdc 
	${CMAKE_SOURCE_DIR}/natpmp
	${SOURCES}
	${HEADERS}
)
add_dependencies(bmdc
	${DEPENDENCIES}
)

target_compile_definitions(bmdc PRIVATE
-D_DATADIR=\"${SHARE_INSTALL_PREFIX}\"
)

target_compile_options(bmdc PUBLIC
	${CANBERRA_CFLAGS}
	${GTK_PLATFORM_INCLUDE_DIRS}
	${MINIUPNP_CFLAGS}
	${OPENSSL_CFLAGS}
	${GEOIP_CFLAGS}
)

target_include_directories(bmdc PUBLIC
	${CMAKE_BINARY_DIR}
	${CMAKE_BINARY_DIR}/src
	${CMAKE_SOURCE_DIR}/dcpp
	${CMAKE_CURRENT_BINARY_DIR}
	${CANBERRA_INCLUDE_DIRS}
	${GTK_PLATFORM_INCLUDE_DIRS}
	${MINIUPNP_INCLUDE_DIRS}
	${OPENSSL_INCLUDE_DIRS}
	${GEOIP_INCLUDE_DIRS}
)

target_link_libraries(bmdc
	${DEPENDENCIES}
	${CANBERRA_LDFLAGS}
	${GTK_PLATFORM_LDFLAGS}
	${MINIUPNP_LIBRARY}
	${GEOIP_LIBRARIES}
	${PCRE_LIBRARY}
	${OPENSSL_LIBRARIES}
	${BZIP2_LIBRARIES}
	${ZLIB_LIBRARIES}
	natpmp
)
set_property (TARGET ${PROJECT_NAME} PROPERTY OUTPUT_NAME "${PROJECT_NAME}")

install(TARGETS bmdc
	DESTINATION ${BIN_INSTALL_DIR}
)

=== natpmp/CMakeLists.txt ===
set(SOURCES
getgateway.c
natpmp.c
wingettimeofday.c)
set(HEADERS getgateway.h declspec.h
natpmp.h)

add_library(natpmp STATIC ${SOURCES})

=== debian/changelog ===
bmdc (0.1.3) trusty; urgency=low

  * BMDC initial,

 -- FreeDC++ <freedcpp@seznam.cz>  Tue, 15 Mar 2011 20:50:35 +0100

=== debian/control ===
Source: bmdc
Section: net
Priority: optional
Maintainer: Mank <Mank1@seznam.cz>
XSBC-Original-Maintainer: Mank <Mank1@seznam.cz>
Build-Depends: 
 cdbs (>= 0.4.85~),
 debhelper (>= 4.2.0),
 patchutils (>= 0.2.25), 
 scons,
 libbz2-dev,
 zlib1g-dev,
 libgtk-3-dev,
 libssl-dev,
 libcanberra-dev,
 libnotify-dev,
 libgeoip-dev,
 libtar-dev,
 libxss-dev,
 bzr
Homepage: http://launchpad.net/bmdc++/
Standards-Version: 3.9.2

Package: bmdc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: BMDC++ Client with Ignore User , Media Spam and many others.
 DC++ Client with Ignore User , Media Spam and many others.
 By Mank and branec ( icons)
 ...
 .
 http://freedcppmv.sourceforge.net/.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
#include /usr/share/cdbs/1/rules/patchsys-quilt.mk
include /usr/share/cdbs/1/class/scons.mk

# In order to regenerate 'debian/control' :
#   DEB_AUTO_UPDATE_DEBIAN_CONTROL=yes fakeroot debian/rules clean
# Then check manually if everything's ok

#DEB_INSTALL_MANPAGES_bmdc := data/linuxdcpp.1
DEB_INSTALL_CHANGELOGS_bmdc := BMDC-Changelog.txt
DEB_SCONS_OPTIONS := release=0 libxattr=0 PREFIX=/usr/ FAKE_ROOT=$(CURDIR)/debian/bmdc

install/bmdc::
	rm -rf $(CURDIR)/debian/bmdc/usr/share/doc/bmdc/License.txt 
	#cp -rf $(CURDIR)/debian/icons/* $(CURDIR)/debian/bmdc/usr/share/pixmaps
	cp $(CURDIR)/data/bmdc.desktop $(CURDIR)/debian/bmdc/usr/share/applications

clean::
	rm -rf build bmdc po/bmdc.pot

=== debian/watch ===
version=3

https://launchpad.net/bmdc++/+download .*bmdc-(.*)\.tar\.bz2
